#!/usr/bin/env python
# -*- coding: utf-8 -*- 
import os.path
import sys
import random
import dircache
import os

#une gruikerie spciale pycc
try:
    os.chdir(os.path.join("plugins", "balltrap"))
except:
    pass

try:
    import pygame
    from pygame.locals import *
except:
    print "-------- pygame module was not found. -------"
    sys.exit (-1)

class ImageLoader:
    """ Used to load Pictures only one time.
    """
    loaded = {}
    def __init__(self, path):
        self.path=path
    
    def load(self, filename, path=None):
        """ return the surface described by filename.
        Load the file if it is necessary.
        """
        if not path:
            path=self.path
        try:
            ret = ImageLoader.loaded[filename]
        except KeyError:
            filejoin = os.path.join(path,filename)
            ret = pygame.image.load(filejoin).convert()
            ImageLoader.loaded[filename] = ret
        return ret

    def load_directory(self, path=None, extensions=['jpg','bmp','png']):
        """ Load all pictures inside a directory
        """
        if not path:
            path=self.path
        for filename in dircache.listdir(path):
            try:
                for extension in extensions:
                    if extension==filename[-3:]:
                       self.load(filename, path)
            except pygame.error,e :
                print "argh : can't load "+filejoin+' '+str(e)

class Duck(pygame.sprite.Sprite):
    """ A duck is an object to be kill. """
    def __init__(self, initial_position,loader, name='anonym'):
        pygame.sprite.Sprite.__init__(self)
        self.name=name
        self.image_g = loader.load('g_duck.png') 
        self.image = self.image_d = loader.load('d_duck.png')
        self.image_k = loader.load('k_duck.png')
        
        self.image_g.set_colorkey([255,255,255])
        self.image_d.set_colorkey([255,255,255])
        self.image_k.set_colorkey([255,255,255])

        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        self.going_down =  random.randint(0,1) 
        self.going_left =  random.randint(0,1)
        self.next_update_time = 0 
        self.alive = True
    
    def update(self, current_time, size):
        """ Update the current position.
            and select the right picture.
        """
        if self.next_update_time < current_time:
            if self.alive == True:
                move = random.randint(1,3)
                if self.rect.bottom >= size[1] - move: self.going_down = False
                elif self.rect.top <= 0: self.going_down = True
                if self.going_down: self.rect.top += move
                else: self.rect.top -= move
            
                if self.rect.left >= size[0] - move - self.rect.width: 
                    self.going_left = False
                elif self.rect.left <= 0:
                    self.going_left = True
                if self.going_left: 
                    self.rect.left += move
                    self.image=self.image_d
                else: 
                    self.rect.left -= move
                    self.image=self.image_g
                if random.randint(1,1000) < 25: #changement aleatoire de sens
                    self.going_left = not self.going_left
            else: # The duck is dead !!!
                self.image=self.image_k
                if self.rect.bottom >= size[1] - 3:
                    self.kill()
                else:
                    self.rect.top += 3
            self.next_update_time = current_time + 10

    def display(self, screen):
        """ draw the duck
        """
        screen.blit(self.image, self.rect)

class Bullet(pygame.sprite.Sprite):
    number=0
    """ a bullet is made when a duck is missed """
    def __init__(self, initial_position,loader,
                 filename='bullet.png'):
        Bullet.number += 1
        print Bullet.number
        
        pygame.sprite.Sprite.__init__(self)
        self.image = loader.load(filename)
        self.image.set_colorkey([255,255,255])
        #self.image.set_alpha(128)
        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        self.rect.top -= self.rect.width/2
        self.rect.left -= self.rect.height/2
        self.next_update_time = 0
        self.live_tick = 300
    
    def update(self, current_time, size):
        """ Update the position of the bullet
        """
        if self.next_update_time < current_time:
            self.live_tick -= 1
            if self.live_tick <= 0:
                self.kill()

    def display(self, screen):
        """ Draw the bullet
        """
        screen.blit(self.image, self.rect)

class Message(pygame.sprite.Sprite):
    """ Message is an object for communicate with the player
    """
    def __init__(self, initial_position,loader,
                 filename='bullet.png',anim=False):
        pygame.sprite.Sprite.__init__(self)
        self.image = loader.load(filename)
        self.image.set_colorkey([255,255,255])
        #self.image.set_alpha(128)
        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        self.next_update_time = 0
        self.live_tick = 300
        self.animation=anim
    
    def update(self, current_time, size):
        """ move the message if self.animation=1.
        And commit suscied if it is the time.
        """
        if self.next_update_time < current_time:
            self.live_tick -= 1
            if self.live_tick <= 0:
                self.kill()
            move = 1
            if self.animation:
                if self.rect.bottom >= size[1] - move: 
                    self.kill()
                self.rect.top += move
            self.next_update_time = current_time + 10

    def display(self, screen):
        """ Draw the message """
        screen.blit(self.image, self.rect)

class Viseur(pygame.sprite.Sprite):
    def __init__(self, initial_position, loader, file_bitmap='viseur.png'):
        pygame.sprite.Sprite.__init__(self)
        self.image = loader.load(file_bitmap).convert()
        self.image.set_colorkey([255,255,255])
        self.rect = self.image.get_rect()
        self.pos(initial_position)

    def pos(self, position):
        self.rect.topleft = position
        self.rect.top -= self.rect.width/2
        self.rect.left -= self.rect.height/2

    def display(self, screen):
        screen.blit(self.image, self.rect)    

class KillThemAll:
    """ The Game. """
    def __init__(self):
        pygame.init()
        self.size = self.width, self.height = 400,300
        self.screen = pygame.display.set_mode(self.size)

        self.ducks = pygame.sprite.Group()
        self.bullets = pygame.sprite.Group()
        self.messages = pygame.sprite.Group()
        self.killed_ducks = pygame.sprite.Group()

        self.imgloader=ImageLoader(path='pic')
        self.imgloader.load_directory()
        for i in range(random.randint(1,3)):
            self.ducks.add(Duck( [random.randint(0,self.width),
                             random.randint(0,self.height)],
                             self.imgloader))
        self.background = self.imgloader.load('dead-duck.png')
        self.screen.blit(self.background, [0, 0])
        self.last_bullet=None
        pygame.mouse.set_visible(False)
        pygame.display.set_caption('KILL THEM ALL!')
        self.viseur=Viseur([0,0], self.imgloader)
        self.memory_nb_duck=3
        self.messages.add(Message([0,0] ,self.imgloader,'go.png', True))
        self.gagnai=False
        self.event=None
        self.killed=[]

    def add_duck(self, duckname):
        self.ducks.add(Duck( [random.randint(0,self.width),random.randint(0,self.height)],
                             self.imgloader,duckname))
    def my_kill(self):
        r=self.killed
        self.killed=[]
        return r
    
    def kill_duck(self, duckname):
        for duck in self.ducks.sprites():
            if duck.name==duckname:
                duck.alive=False
                duck.kill()
                self.killed_ducks.add(duck)
                
    def __read_event__(self):
        """ Read and execute event """
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                self.please_go=0
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
                self.event=event
                self.last_bullet=Bullet([event.pos[0],event.pos[1]] ,
                                        self.imgloader)
                self.gagnai=False
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 3:
                self.ducks.add(Duck([event.pos[0],event.pos[1]],
                                    self.imgloader))
                self.event=event
                self.messages.empty()
                self.messages.add(Message([0,0] ,
                                         self.imgloader,
                                         'go.png',
                                         True))

    def run(self):
        """Start the event loop and the game. """
        self.please_go=1
        while self.please_go==1:
            self.__read_event__()
            time = pygame.time.get_ticks()

            if self.last_bullet:
                kill_list= pygame.sprite.spritecollide(self.last_bullet,
                                                       self.ducks,True)
                if kill_list:
                    if len(kill_list)>1:
                        self.messages.add(Message([self.event.pos[0],
                                                  self.event.pos[1]],
                                            self.imgloader, 'powa.png' ))
                    for kd in kill_list:
                        kd.alive=False
                        if kd.name != 'anonym':
                            self.killed.append(kd.name)
                        self.killed_ducks.add(kd)
                else:
                    self.bullets.add(self.last_bullet)

            if len(self.ducks)==0 and self.gagnai==False:
                self.gagnai==True
                self.messages.empty()
                self.messages.add(Message(self.viseur.rect.topleft,
                                         self.imgloader,
                                         'gagnai.png', False))
            if self.memory_nb_duck<>len(self.ducks) and len(self.ducks)==1:
                self.messages.add(Message([0,0] ,
                                         self.imgloader,
                                         'last.png',
                                         True))
            self.memory_nb_duck=len(self.ducks)
            self.draw(time)

    def draw(self, time):
        """draw the scene """
        self.screen.blit(self.background, [0,0])
                    
        self.messages.update(time, self.size)
        [b.display(self.screen) for b in self.messages.sprites()]
                            
        self.bullets.update(time, self.size)
        [b.display(self.screen) for b in self.bullets.sprites()]

        self.killed_ducks.update(time, self.size)
        [b.display(self.screen) for b in self.killed_ducks.sprites()]

        self.ducks.update(time, self.size)
        [b.display(self.screen) for b in self.ducks.sprites()]

        self.viseur.pos(pygame.mouse.get_pos())
        self.viseur.display(self.screen)

        self.__ending_render__()

    def __ending_render__(self):
        self.last_bullet=None
        pygame.display.update()
        pygame.time.wait(10)
        self.event=None
#-- TEST
import threading
from SimpleXMLRPCServer import *

class RPCStub:
    def __init__(self, game):
        self.game=game
    def add_duck(self, duck_name):
        """ Ajout d'un canard.
        """
        print "Ajout d'un canard "+duck_name
        game.add_duck(duck_name)
        return 1

    def kill_duck(self, duckname):
        print "MORT A "+duckname
        game.kill_duck(duckname)
        return 1
    
    def num_of_ducks(self):
        return len(game.ducks)

    def my_kill(self):
        return game.my_kill()

    def quit(self):
        print "quit"
        game.please_go=0
        pygame.event.post(pygame.event.Event(pygame.USEREVENT,{}))
        return 0
    
class CustomXMLRPCServer(SimpleXMLRPCServer):
    def serve_forever(self):
        #self.socket.settimeout(1)
        while self.serving==1:
            self.handle_request()

class KillThemAllThread(threading.Thread):
    def run(self):
        self.server = CustomXMLRPCServer(("localhost", 8000))
        self.server.serving=1
        self.server.allow_reuse_address = True
        self.stub=RPCStub(self.game)
        self.server.register_instance(self.stub)
        self.server.serve_forever()

if __name__=='__main__':
    print """Kill Them All !!!
    (c) 2006 Pufituto Prod. <renardjb@free.fr> All rights reserved.

    \tThis program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    """
    game=KillThemAll()

    stand_alone=0
    for arg in sys.argv:
        if arg=='--noserver':
            stand_alone=1

    if stand_alone==0:
        print "start RPC server"
        k=KillThemAllThread()
        k.game=game
        k.start()
    else:
        print "RPC server not actived"
    game.run()

    #on achve le server
    if stand_alone==0:    
        k.server.serving=0
        from xmlrpclib import *
        server = ServerProxy("http://localhost:8000") # local server
        try:
            print server.quit()
        except Error, v:
            print "ERROR", v
    print "EXITING"





