# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module Eliza
##   Ce module dfinit le plug-in Eliza (psy  la emacs)
##   Egalement, une interface pour A.L.I.C.E. ainsi que Cybelle
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from coinlib.parsers import zapEntities

import string, re, urllib
from random import randrange, choice

def build_plugins(pycc):
  return { \
    'Eliza': Eliza(pycc, "Eliza", "Un bot-psy genre emacs doctor"),
    'Alice': Alice(pycc, "Alice", "Un bot conversationnel (www.alice.org)"),
    'Cybelle': Cybelle(pycc, "Cybelle", "Un bot conversationnel (www.agentland.com)")
  }


class Eliza(HttpBotPlugin):
  
  def set_defaults(self):
    self.options.set('bot_name', self.name)
    self.options.set('bot_data', 'Entry1')
    self.options.set('bot_server', "www-ai.ijs.si")
    self.options.set('bot_url', "/cgi-bin/eliza/eliza_script")
  
  def parse_res(self, res):
    start = res.find("<strong>Eliza:</strong>") + 24
    end = res.find("<form", start) - 1
    return res[start:end]
  

class Alice(HttpBotPlugin):
  
  def set_defaults(self):
    self.options.set('bot_name', self.name)
    self.options.set('bot_data', 'input')
    self.options.set('bot_server', "www.pandorabots.com")
    self.options.set('bot_url', "/pandora/talk?botid=f5d922d97e345aa1&skin=custom_input")
  
  def parse_res(self, res):
    start = res.rfind("<em>")+4
    end = res.find("</em>", start)
    return res[start:end]
  

class Cybelle(HttpBotPlugin):
  
  def set_defaults(self):
    self.options.set('bot_name', self.name)
    self.options.set('bot_data', 'text')
    self.options.set('bot_server', "www.agentland.com")
    self.options.set('bot_url', "/cgi-bin/Alice/cybelle.us.cgi")
  
  def init(self):
    self.session = ""
  
  def getcookie(self, data=None):
    res = HttpBotPlugin.getcookie(self)
    if not res:
      print "## Cybelle: getcookie a ratai"
      return
    start = res.find('<INPUT TYPE="hidden" NAME="session" VALUE="')
    end = res.find('"', start+44)
    self.session = res[start+43:end]
    # On fait une premire requte pour viter la question bte "comment tu t'appelles"
    self.bot_query("Moule")
  
  def bot_query(self, text):
    data = {'session': self.session, 'virtual': '<client_id>'}
    return HttpBotPlugin.bot_query(self, text, data, 'get')
  
  def parse_res(self, res):
    end = res.rfind("</small>")
    start = res[:end].rfind("<small>")+7
    msg = res[start:end]
    print "### Cybelle response:", repr(msg)
    start = msg.find("<script")
    if start >= 0:
      end = 0
      toto = ""
      while start >= 0:
        toto += msg[end:start]
        end = msg.find("</script", start)
        end += 9
        start = msg.find("<script", end)
      toto += msg[end:]
    else:
      toto = msg
    try:
      topost = zapEntities(toto.replace("\n", " "), bouchot.trib.options.val('encoding'))
    except:
      topost = toto
    return topost.strip()
  
