# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module cowboyz
##   Ce module dfinit le plug-in c0wb0yz
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *

semaphore_map = { \
  'A': '/o!', 'N': '/o\\', 
  'B': '_o!', 'O': '_\\o', 
  'C': '\\o!', 'P': '_o', 
  'D': 'o!', 'Q': '_o/', 
  'E': '!o/', 'R': '_o_', 
  'F': '!o_', 'S': '_o\\', 
  'G': '!o\\', 'T': '\\o', 
  'H': '_/o', 'U': '\\o/', 
  'I': '/o', 'V': 'o\\', 
  'J': 'o_', 'W': 'o/_', 
  'K': '/o', 'X': 'o<',
  'L': '/o/', 'Y': '\\o_',
  'M': '/o_', 'Z': 'o\\_'
}

pam_erohpames = {}
for (key, val) in semaphore_map.items():
  pam_erohpames[val] = key

def build_plugins(pycc):
  return { \
    'semaphoreencode': SemaphoreEncode(pycc, "Semaphore Encoder", "Code le texte en smaphore"),
    'semaphoredecode': SemaphoreDecode(pycc, "Semaphore Decoder", "Dcode un texte en smaphore en texte ... lisible")
  }

class SemaphoreEncode(TextPlugin):
  
  def get_style(self):
    return None
  
  def text_transform(self, text, tags={}):
    res = ''
    for ch in text:
      uch = ch.upper()
      if uch in "   \n":
        if res[-2] == ":": continue
        res += ": "
      elif uch in semaphore_map.keys():
        res += semaphore_map[uch]+" "
      else:
        res += ch+" "
    if res[-2] == ":": res = res[:-2]
    return res
  
class SemaphoreDecode(TextPlugin):
  
  def get_style(self):
    return None
  
  def text_transform(self, text, tags={}):
    res = ''
    for word in text.split(":"):
      for letter in word.split(" "):
        if letter in pam_erohpames.keys():
          res += pam_erohpames[letter].lower()
        else:
          res += letter
      res += " "
    return res
