# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in Smileys-Selector
##   Plugin pour le bookmark des totoz
##   auteur: schyzomarijks, modifi par chrisix
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')

from coinlib.plugin import *
from cointklib.dialogs import *

def build_plugins(pycc):
  return { \
    'SmileysSelector': SmileysSelector(pycc, "Totoz-smileys bookmarks", "Affiche les smileys bookmarks.")
  }

class PlugSelectDialog(CoinDialog):

  def __init__(self, pycc, parent, plugin, title=None, text='', **kwargs):
    self.pycc = pycc
    self.text = text
    self.plugin = plugin
    self.kwargs = kwargs
    CoinDialog.__init__(self, parent, title, buttons=[BUT_DEL, 'Copier', BUT_CLOSE])
  
  def bind_button(self, button):
    if button == 'Copier':
      return self.add_to_palmi
  
  def body(self, master):
    Label(master, text=self.text).pack(side=TOP, padx=6)
    self.listb = SortedListBox(master, self.plugin.options.val('book_totoz'), **self.kwargs)
    self.listb.pack(padx=6, pady=6, fill=BOTH, expand=1)
    self.labl = Label(master)
    self.labl.pack(padx=6, pady=6, fill=BOTH, expand=1) ;
    self.listb.bind_select(self.onSelect)
    self.listb.select('totoz')
  
  def onSelect(self):
    bouchot = self.pycc.bouchots[self.pycc.cur_bouchot]
    if bouchot.trib.pinni.getSmiley(self.listb.selected):
      self.labl.configure(image=self.pycc.images[self.listb.selected])
  
  def delete(self):
    if not self.listb.selected:
      return
    self.listb.remove(self.listb.selected)
    self.plugin.options.set('book_totoz', self.listb.getAll())
    self.plugin.options.save()
  
  def add_to_palmi(self):
    if not self.listb.selected:
      return
    self.plugin.pycc.palmi.palmi.inserter('[:'+self.listb.selected+'] ')
  

class SmileySelectorOption(OptionSet):
  def setName(self, name):
    self.name = "SmileysSelector"

  def setObjects(self):
    self._objects = {  
      'book_totoz': Option("Totoz bookmarkes", [],TYPE_LIST),
      'toedit': Option("Editables", {"General": ['book_totoz']})
    }

class SmileysSelector(Plugin):
  def load_config(self):
    # lit le bookmark
    log.info("load config smiley selector")
    self.options = SmileySelectorOption(path=self.config_path)
    self.options.save()

  def config_frame(self, master):
    return OptionsEditor(master, self.options, self.pycc)

  def action_menu(self):
    PlugSelectDialog(self.pycc, self.pycc.root, self, "Smileys Selector", 
                     "Choisir le smiley", width=40, height=8)
  
  def process(self, bouchot, context, post=None, keyword=None, ctxt_tags=[], *args, **kwargs):
    # if not bouchot.trib.options.val('disp_smileys'): return
    if post is None: return
    smiley_list = [ tag for tag in ctxt_tags if tag[:7] == "smiley_" ]
    if not smiley_list:
      smiley_list = [ tag for tag in post.tags.keys() if tag[:7] == "smiley_" ]
    lst = self.options.val('book_totoz')
    for tag in smiley_list:
      if tag[7:] not in lst:
        lst.append(tag[7:])
    self.options.set('book_totoz', lst)
    self.options.save()
